{{   1stTry_LinearCable-Actuator_LCDgearSettingREV9D.spin -
I added an initial LCD print to show the Object Revision on startup. CHANGE THAT WHEN UPDATING REV FILENAME!!
*******************************

REV9D IS WORKING PRETTY GOOD.
I CAN GO BACK AND FORTH BETWEEN RUN, JOG AND SaveToEEPROM using
BUTN1 as the escape and enter key.
I'll need to see if, after giving it a rest for a day or two, if I can still control it properly.
2/16/2016
**************************
I'm using Menue_Driven_object_GG-2016_REV2.spin as the
menue example because it works the way I want and seems like a solid example.
I Wrote the Menue_Driven object with much help from Parallax Forum guys.
************************** 
Menu's are determined by BUTN4 
After proper menu selection is done, BUTN1 goes to the selection made by BUTN4.
**************************
I set "Speed" variable to 1500, then 2000
In RUN mode, the "Speed" variable sets the motor speed.
In JOG mode the Speed is set to 1000 when pressing BUTN3, When pressing BUTN4 Speed is set by Speed Variable.
This helps to more accurately position the actuator because BUTN4 runs pretty fast.
************************** 
2/4/16

------------------------------------------------
  This appears to work on the prop mini.
  The LCD updates correctly and the WaitPeq statement seems to work correctly.
  The endless loop driving the step motor is currently connected to LED's and that also appears to
  be working correctly.
  Next step is to test the BigEasyDriver when it's connected to 12V.
  I've soldered the 3/5 connection closed so the BigEasyDriver is running it's logic at 3.3V.
  There are 20K pullup resistors on the BED logic control except for the Enable pin.
  I used no resistors from pulled up logics BUT I placed a 3.3K resistor from BED Enable pin to the
  Pin 7 on the PropMini for BED enable/disable from this object,
************************** 
  PropMini to the BigEasyDriver. 2/1/2016 at 4:52pm
  I connected the BigEasyDriver GND, Step, Dir pins to the PropMini using no resistors on the PropMini outputs.
  I power up the BigEasyDriver 1st then power up the PropMini
  The BigEasyDriver runs cool enough that I can put my finger on the driver chip and hold it there.
  This all is working good.
************************** 

SparkFun BigEasyDriver v1.2 ROB-12859 and Sparkfun Stepper Motor ROB-10846 68oz.in(400 Full steps/rev)
Step motor data sheet says:

Model 42BYGH M809, Step angle 0.9 degrees, Volts/coil 2.8v, current 1.7amps, coil resistence 1.65ohms
data sheet from WANTI MOTOR COMPANY.

BigEasyDriver to be powered with 8 AA batteries = 12volts using regular AA batteries
or 9.6volts using the Nickel rechargables.

BigEasyDriver Setup.  Original TP1 voltage was 1.7V, that allows about 2Amps current to flow.
I set the TP1 voltage to 0.88v, this should give about 1amp Drive current.
With TP1 set to 0.88v, the BigEasyDriver runs pretty cool.

I also have the MS1, MS2 and MS3 pins grounded on the BigEasyDriver to give full 0.9 degree steps.


..
PropMini power should be 5 AA batteries = 7.5volts or 6volts with rechargables.
..
Parallax 2 Line LCD to be powered from the available 5V pin of the prop mini.
I put 4.7k resistor from PropMini pin 18 to signal pin on the LCD. to limit current on the PropMini.
LCD draws about 20ma current.
..
Actuator uses 4mm bolt
Coarse thread is 0.7mm pitch
Fine thread is 0.5mm pitch
Assuming coarse pitch, 5 revolutions of the bolt should move the nut 0.137795"
at 400 steps/rev it would take 2 full seconds using 1ms pulses - 500microseconds on/500microseconds off
..
Initial testing of PropMini power supply shows that PropMini and LCD draws 0.035 A on startup.
  While running the step motor and updating display current draw is 0.046 A
..     
Initial testing of the BigEasyDriver shows that at idle condition with BED disabled curent draw is 0.010 A
  While running, the step motor draws 0.260 A
..
Now, I'll need to think about reducing current draw, but for now, it's not bad.
2/17/2016
                                                           
}}

CON
' Set Processor Speed @ 80mhz
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

' Global Pin Assignments for Sparkfun Big Easy Driver v1.2 board 
  StepPin = 1   'Tied High on BigEasyDriver with 20K resistor, Pull low to step
  DirPin  = 0   'Tied High on BigEasyDriver with 20K resistor, Pull low for reverse
  SleepPin = 2  'Tied High on BigEasyDriver with 20K resistor, Pull Low to sleep. Wait 1ms after wakeup before Stepping the motor                 
                ' Wait 1ms after wakeup before Stepping the motor. Sleep is BigEasyDriver low power mode
  BEDrstPin = 3 'Tied High on BigEasyDriver with 20K resistor, Pull low then High to reset.
  MS3_Pin = 4   'MS3_, MS2_, MS1_ all tied High on BigEasyDriver with 20K resistor, All Low will be full step
  MS2_Pin = 5
  MS1_Pin = 6
  EN_Pin = 7    'Pulled down on BigEasyDriver with 20K resistor, To Disable, pull High then Step the motor. 
' Lcd Pin Assignment
  LCD_Pin = 18
' Global Pin Assignments for Pushbutton_Board-2ndTry
' Pushbuttons start at the bottom of the board.                           
' Pushbuttons 5 and 6 might be used as limit switches.
  BUTN1 = 8
  BUTN2 = 9
  BUTN3 = 10
  BUTN4 = 11
  BUTN5 = 12
  BUTN6 = 13
  BUTNCOGLED = 16         'This is for the LED used when I press BUTN3 or BUTN4 to signal a gearchange.
  
  
VAR
  ' Gear1 thru Gear8 are the exact step count when each gear is positioned for riding.
  ' Once the Gear positions are set, these variables will not change in value
  ' The plan is, after calibrating for proper shifting, the Gear1 thru Gear8 numbers should be saved to upper EEPROM memory.
  
  Long Speed
  Long StepCount   ' current step position
  Long Gear1
  Long Gear2
  Long Gear3
  Long Gear4
  Long Gear5
  Long Gear6
  Long Gear7
  Long Gear8
  Long CurrentGear     'This is the current gear it will be a value of 1 through 8
  Long BeenThere       'This will be a number from 1 through 8 that says the step motor should be at it's destination.
                       'BeenThere is initially at 0 and changes depending on which gear is selected.        
  Long Flag1
  Long Flag2
  Long Flag3
  Long Flag4
  Long MENUE            'Variable used to send the program to Jogging or Running to position.
  Long LeavingMethod     'Variable When leaving a method, set this to 1,  When entering Set to 0
                        'LeavingMethod is set to 0 initially in PUB Main.
  Long mask          'Used to set up the Waitpne instruction in MainMenue method   
OBJ
  ' FullDuplexSerial will be used to drive the Parallax 2 line LCD display
  
  LCD : "FullDuplexSerial"
                  
PUB  Main 

dira[StepPin]~~                        ' Set StepPin to OUTPUT
dira[DirPin]~~                         ' Set DirPin to OUTPUT
dira[MS1_Pin]~~                        ' Set MS1_Pin to OUTPUT
dira[MS2_Pin]~~                        ' Set MS2_Pin to OUTPUT
dira[MS3_Pin]~~                        ' Set MS2_Pin to OUTPUT
dira[EN_Pin]~~                         ' Set Enable Pin to OUTPUT
outa[StepPin]~                         ' Set Step pin to low to initialize
outa[DirPin]~                          ' Set Direction pin to low to initialize
outa[EN_Pin]~~                         ' Set Enable Pin High to Disable, Use 3.3K resistor on prop pin.
'MS1, MS2, MS3 all low = Full Step Mode
outa[MS1_Pin]~                         
outa[MS2_Pin]~
outa[MS3_Pin]~                    

waitcnt(clkfreq * 3 + cnt)             ' 3sec Delay Before Starting   
{{
Use this area for setting up the linear Actuator Sleep cycle.
Pressing up-shift or down-shift button will wake up the sleeping PropMini.
..
Check to see if the PropMini maintains the outputs in the condition that existed when the PropMini was
put to sleep.  I think this will be the WaitPEQ, I'm not really sure. 1-19-16  
WaitPEQ should work for this.
}}
  'LCD, Gear1 position, StepCount current position setup
 
  'Setup for initial presets of Gear1 position and StepCount current position
  Speed:= 2000        'This sets the speed of the step motor, 2000 is pretty good can be lower or higher.
  Gear1:= 1000  '2800        '7 revolutions at 200 steps per revolution gives me 3/16" approx travel.
  Gear2:= 2000  '5600
  Gear3:= 3000  '8400
  Gear4:= 4000  '11200
  Gear5:= 5000  '14000
  Gear6:= 6000  '16800
  Gear7:= 7000  '19600
  Gear8:= 8000  '22400
  StepCount:=500
  CurrentGear:=1
  Flag1:=0           'Flag for BUTN1
  Flag2:=0           'Flag for BUTN2 
  Flag3:=0           'Flag for BUTN3                       
  Flag4:=0           'Flag for BUTN4   
  MENUE:=1
  LeavingMethod:=0  'Used when leaving and entering method via single press of BUTN1
' Make pins 8,9 and 10 input
' Pin 8-BUTN1 allows setting of Gear1 and StepCount data, Pin 9-BUTN2 will be increase, Pin 10-BUTN3 will be Decrease
' Pin 11-BUTN4 will be increase
dira[BUTN1] := 0
dira[BUTN2] := 0                              '
dira[BUTN3] := 0
dira[BUTN4] := 0
dira[BUTNCOGLED]~~                    'Make BUTNCOGLED an output
outa[BUTNCOGLED]~                     'Make BUTNCOGLED LOW                             

  mask := (|<BUTN1) | (|<BUTN4)  'OR the two button masks together into a single value.  Used in the MainMenue method.

  LCD.start(LCD_Pin, LCD_Pin, %1000, 9_600)  'This is setting for LCD display.
  waitcnt(clkfreq / 10 + cnt)           ' Pause for 100ms to initialize the LCD display.  


     'Set up and display initial program REVISION loaded on PropMini One time on Boot-up
     
       LCD.tx(12)                            ' Clear the LCD display
       waitcnt (60_000 + cnt)                ' Pause for 5ms time for LCD display to clear
  
       LCD.str(string("This is REV9D  "))   ' line 0 printed to LCD                                      
       LCD.tx(13)                            ' Line feed
       LCD.str(string("BUTN1=To MENU  "))   ' line 1 printed to LCD
       LCD.tx(212)                           ' Set quarter note
       LCD.tx(220)                           ' A tone             
      

  Waitpeq (|<BUTN1, |<BUTN1, 0)          'Pause program execution until button ina[8] is pressed and held.  
  Waitpne (|<BUTN1, |<BUTN1, 0)          'Pause program execution until button ina[8] is NOT pressed .    

 repeat


    MAIN_MENUE                       ' Calls the next method

pub MAIN_MENUE           'This is MAIN_MENUE FROM "Menu_Driven_Object_gg-2016_REV2"



     'Set up and display initial MENUE LCD view.
       LCD.tx(12)                            ' Clear the LCD display
       waitcnt (60_000 + cnt)                ' Pause for 5ms time for LCD display to clear
  
       LCD.str(string("MENU"))               ' line 0 printed to LCD                                      
       LCD.tx(13)                            ' Line feed
       LCD.str(string("BUTN4 = Select"))     ' line 1 printed to LCD
       LCD.tx(212)                           ' Set quarter note
       LCD.tx(220)                           ' A tone             
       MENUE:=0                              'Needed to reinitialize variable MENUE * IMPORTANT
       Beenthere := 0                        'Reset the "BeenThere" variable for reuse in RUN * IMPORTANT
 repeat                     
            IF MENUE==4                      'MENUE:=4 Is set as last statement before returning from
               QUIT                          '         the FirstMenue, SecondMenue and ThirdMenue methods. 


            Waitpne (|<BUTN1, |<BUTN1, 0)          'Pause program execution until button BUTN1 is NOT pressed . 
            If INA[BUTN1]==0                       'BUTN1 must be released to enable BUTN1 again.
               Flag1:=0                            'Flag1 says that the BUTN1 has been released. 
            If INA[BUTN4]==0                       'BUTN4 must be released to enable BUTN4 again.
               Flag4:=0                            'Flag4 says that the BUTN4 has been released.
                            
            waitpne(  0 , mask , 0 )       'wait for either BUTN1 or BUTN4 to be set. mask is defined in the VAR section.      
                                           'mask is defined in the VAR section. 

            IF INA[BUTN4]==1 and Flag4==0

                   Flag4:=1

                   MENUE:= MENUE+1

                    IF MENUE>3
                       MENUE:=1         

       if Flag4==1   
          Case MENUE
            1 : 
                LCD.TX(12)                          'Clear the LCD screen.
                waitcnt(clkfreq / 200 + cnt)        'Wait 5ms for screen to clear.  This is 1 / 0.005 seconds  
                LCD.str(String("RUN"))             
                LCD.TX(148)                         'Move cursor to Line1 position 0
                LCD.str(String("                ")) 'Print 16 spaces to clear line 1                
                LCD.TX(148)                         'Move cursor to Line1 position 0               
                LCD.str(String("GoTo = BUTN1"))     'Instruction to go to this method                                               
            2 : 
                LCD.TX(12)                          'Clear the LCD screen.
                waitcnt(clkfreq / 200 + cnt)        'Wait 5ms for screen to clear.  This is 1 / 0.005 seconds  
                LCD.str(String("TO Jog?"))      
                LCD.TX(148)                         'Move cursor to Line1 position 0
                LCD.str(String("                ")) 'Print 16 spaces to clear line 1                
                LCD.TX(148)                         'Move cursor to Line1 position 0               
                LCD.str(String("GoTo = BUTN1"))     'Instruction to go to this method                             
            3 :
                LCD.TX(12)                          'Clear the LCD screen.
                waitcnt(clkfreq / 200 + cnt)        'Wait 5ms for screen to clear.  This is 1 / 0.005 seconds  
                LCD.str(String("TO SaveToEEPROM?"))      
                LCD.TX(148)                         'Move cursor to Line1 position 0
                LCD.str(String("                ")) 'Print 16 spaces to clear line 1                
                LCD.TX(148)                         'Move cursor to Line1 position 0               
                LCD.str(String("GoTo = BUTN1"))     'Instruction to go to this method       

        Flag4:=2                                    'Flag4:=2 is used so the Case MENU does not keep repeating.
                                                    'This stops the MENUE from updating if BUTN4 is staying pressed.
   
       If INA[BUTN1]==1 and Flag1==0

{{               'The following 3 lines of CODE are just a test point, to be erased when things are working correctly
                  'This can be inserted anyplace in the Object temporarily to troubleshoot my coding errors.
               LCD.TX(128)                                       'Move cursor to Line0 position 0 
               LCD.str(string("test point #1   "))               ' This is a test marker.           
               Waitpeq (|<BUTN2, |<BUTN2, 0)          'Pause program execution until button BUTN2 is pressed .   
}}
                    Flag1:=1            

           Case MENUE                 '"Case MENUE" sends program to the proper method.
              1 : RUN       

              2 : JOG      
                                   
              3 : SaveToEEPROM                                                      

      
 'Program returns here from either RUN, JOG OR SaveToEEPROM.
 'THEN the program returns to Main because MENUE is set to 4 at the end of RUN, JOG OR SaveToEEPROM.  

Pub RUN
{{  This is a Never Ending Loop that selects the next gear and the program gets directed
to the FirstGear through EighthGear methods.
After the FirstGear through EighthGear methods have been exicuted, program returns to this loop.
I used the CASE strategy to make the selection.
It appears to work pretty good.  2/5/2016
}}

  Waitpne (|<BUTN1, |<BUTN1, 0)          'Pause program execution until button BUTN1 is NOT pressed .    
                                         'I'm not sure if this is correct place for this Waitpne instruction.
                                         'BUTN1 needs to not be pressed for this method to run correctly.

   Repeat                                          'Endless Loop               



         if ina[BUTN1]==1               'This should get you back to the initial MAIN_MENUE

            quit
        

         If INA[BUTN3]==0               'The Flag3 set to 0 when BUTN3 is unpressed caused you to need to         
            Flag3:=0                    'release the BUTN3 between gear changes. 
         If INA[BUTN3]==1                      
           if Flag3==0
                   CurrentGear:=CurrentGear-1
                   If CurrentGear<1
                      CurrentGear:=1
                Flag3:=1                'Sets Flag3 to 1 so that the BUTN3 must be released before selecting the next gear.
                outa[BUTNCOGLED]~~                  ' Set BUTNCOGLED HIGH to start pulse   

         If INA[BUTN4]==0                'The Flag4 set to 0 when BUTN4 is unpressed caused you to need to      
            Flag4:=0                     'release the BUTN4 between gear changes. 
         If INA[BUTN4]==1
           If Flag4==0
                   CurrentGear:=CurrentGear+1
                   If CurrentGear>8
                      CurrentGear:=8
                Flag4:=1                 'Sets Flag4 to 1 so that the BUTN4 must be released before selecting the next gear.    
                outa[BUTNCOGLED]~~                  ' Set BUTNCOGLED HIGH to start pulse   



     if BeenThere <> CurrentGear            'BeenThere is set to the number of the gear when running methods FirstGear through EighthGear.

        LCD.tx(12)                          ' Clear the LCD display
        waitcnt(clkfreq / 200+ cnt)         ' Pause for 5ms time for LCD display to clear
  
        LCD.str(string("CurrentGear     ")) ' line 0 printed to LCD                                      
        LCD.tx(141)                         ' Move cursor to Line 0 position 13 
        LCD.Dec(CurrentGear)                ' CurrentGear data printed to LCD
        LCD.tx(212)                         ' Set quarter note
        LCD.tx(220)                         ' A tone      
         outa[BUTNCOGLED]~                  ' Set BUTNCOGLED Low  
          
        Case CurrentGear                    'The value of CurrentGear is the gear I want to send the program to.
           1 : Firstgear                    'The Firstgear through EighthGear are calls to send program to those methods
           2 : SecondGear
           3 : ThirdGear
           4 : FourthGear
           5 : FifthGear
           6 : SixthGear
           7 : SeventhGear
           8 : EighthGear


  MENUE:=4       'If MENUE is equal to 4, the implied return sends program back to MAIN_MENUE, where the
                'repeat loop is canceled.

Pub FirstGear                                  

outa[EN_Pin]:=0                           'Enable the Big Easy driver
Beenthere := 1

If StepCount==Gear1
     return
  


    LCD.tx(12)                            ' Clear the LCD display
    waitcnt(clkfreq / 200+ cnt)           ' Pause for 5ms time for LCD display to clear
  
    LCD.str(string("CurrentGear"))        ' line 0 printed to LCD                                      
    LCD.tx(141)                           ' Move cursor to Line 0 position 13
    LCD.Dec(CurrentGear)                  ' Current Gear "1 through 8" printed to LCD
    LCD.tx(148)                           ' Move cursor to Line 1 position 0
    LCD.str(string("----------------"))   ' Print dashes across Line 1
    LCD.tx(212)                           ' Set quarter note
    LCD.tx(220)                           ' A tone      
'--------------------------------------------------------------------------------------------------------------
Repeat

   if StepCount > Gear1
      outa[Dirpin]~                      'Set Direction pin to LOW for Reverse     
      outa[StepPin]~~                  ' Set StepPin HIGH to start pulse       1step @ fullstep = 0.9deg
       waitcnt(clkfreq / Speed + cnt)  ' Pulse HIGH time 15000 is less than 100 microseconds
                                       ' Pulse HIGH time 1_000 = 0.001 seconds or 1ms
      outa[StepPin]~                   ' Set StepPin LOW to end pulse
       waitcnt(clkfreq / Speed + cnt)  ' Pulse LOW time 15000 is less than 100 microseconds
                                       ' Pulse  time 1_000 = 0.001 seconds or 1ms
      outa[StepPin]~~                  ' Set StepPin HIGH to start pulse       1step @ fullstep = 0.9deg
       waitcnt(clkfreq / Speed + cnt)  ' Pulse HIGH time 15000 is less than 100 microseconds
                                       ' Pulse HIGH time 1_000 = 0.001 seconds or 1ms
      outa[StepPin]~                   ' Set StepPin LOW to end pulse
       waitcnt(clkfreq / Speed + cnt)  ' Pulse LOW time 15000 is less than 100 microseconds
                                       ' Pulse  time 1_000 = 0.001 seconds or 1ms
       StepCount := StepCount-2                                           

     If StepCount==Gear1

        LCD.tx(148)                    ' Move cursor to Line 1 position 0  
        LCD.Dec(StepCount)


         outa[EN_Pin]:=1               'Disable the Big Easy driver, make it High  

          return

   if StepCount < Gear1
    outa[Dirpin]~~                     'Set Direction pin to High for Forward   
      outa[StepPin]~~                  ' Set StepPin HIGH to start pulse       1step @ fullstep = 0.9deg
       waitcnt(clkfreq / Speed + cnt)  ' Pulse HIGH time 15000 is less than 100 microseconds
                                       ' Pulse HIGH time 1_000 = 0.001 seconds or 1ms
      outa[StepPin]~                   ' Set StepPin LOW to end pulse
       waitcnt(clkfreq / Speed + cnt)  ' Pulse LOW time 15000 is less than 100 microseconds
                                       ' Pulse  time 1_000 = 0.001 seconds or 1ms
      outa[StepPin]~~                  ' Set StepPin HIGH to start pulse       1step @ fullstep = 0.9deg
       waitcnt(clkfreq / Speed + cnt)  ' Pulse HIGH time 15000 is less than 100 microseconds
                                       ' Pulse HIGH time 1_000 = 0.001 seconds or 1ms
      outa[StepPin]~                   ' Set StepPin LOW to end pulse
       waitcnt(clkfreq / Speed + cnt)  ' Pulse LOW time 15000 is less than 100 microseconds
                                       ' Pulse  time 1_000 = 0.001 seconds or 1ms
      StepCount := StepCount+2                                           

     If StepCount==Gear1

        LCD.tx(148)                    ' Move cursor to Line 1 position 0  
        LCD.Dec(StepCount)

         outa[EN_Pin]:=1               'Disable the Big Easy driver, make it High  

        return
 
Pub SecondGear  
outa[EN_Pin]:=0                        'Enable the Big Easy driver        
Beenthere := 2
If StepCount==Gear2
  return

LCD.tx(12)                             ' Clear the LCD display
 waitcnt(clkfreq / 200+ cnt)           ' Pause for 5ms time for LCD display to clear
  
 LCD.str(string("CurrentGear"))        ' line 0 printed to LCD                                      
 LCD.tx(141)                           ' Move cursor to Line 0 position 13
 LCD.Dec(CurrentGear)                  ' Current Gear "1 through 8" printed to LCD
 LCD.tx(148)                           ' Move cursor to Line 1 position 0
 LCD.str(string("----------------"))   ' Print dashes across Line 1
 LCD.tx(212)                           ' Set quarter note
 LCD.tx(220)                           ' A tone      
'--------------------------------------------------------------------------------------------------------------
Repeat

   if StepCount > Gear2
    outa[Dirpin]~                      'Set Direction pin to LOW for Reverse     
      outa[StepPin]~~                  ' Set StepPin HIGH to start pulse       1step @ fullstep = 0.9deg
       waitcnt(clkfreq / Speed + cnt)  ' Pulse HIGH time 15000 is less than 100 microseconds
                                       ' Pulse HIGH time 1_000 = 0.001 seconds or 1ms
      outa[StepPin]~                   ' Set StepPin LOW to end pulse
       waitcnt(clkfreq / Speed + cnt)  ' Pulse LOW time 15000 is less than 100 microseconds
                                       ' Pulse  time 1_000 = 0.001 seconds or 1ms
      outa[StepPin]~~                  ' Set StepPin HIGH to start pulse       1step @ fullstep = 0.9deg
       waitcnt(clkfreq / Speed + cnt)  ' Pulse HIGH time 15000 is less than 100 microseconds
                                       ' Pulse HIGH time 1_000 = 0.001 seconds or 1ms
      outa[StepPin]~                   ' Set StepPin LOW to end pulse
       waitcnt(clkfreq / Speed + cnt)  ' Pulse LOW time 15000 is less than 100 microseconds
                                       ' Pulse  time 1_000 = 0.001 seconds or 1ms
       StepCount := StepCount-2                                           


     If StepCount==Gear2

        LCD.tx(148)                    ' Move cursor to Line 1 position 0  
        LCD.Dec(StepCount)

         outa[EN_Pin]:=1               'Disable the Big Easy driver, make it High  

          return

   if StepCount < Gear2
    outa[Dirpin]~~                     'Set Direction pin to High for Forward   
      outa[StepPin]~~                  ' Set StepPin HIGH to start pulse       1step @ fullstep = 0.9deg
       waitcnt(clkfreq / Speed + cnt)  ' Pulse HIGH time 15000 is less than 100 microseconds
                                       ' Pulse HIGH time 1_000 = 0.001 seconds or 1ms
      outa[StepPin]~                   ' Set StepPin LOW to end pulse
       waitcnt(clkfreq / Speed + cnt)  ' Pulse LOW time 15000 is less than 100 microseconds
                                       ' Pulse  time 1_000 = 0.001 seconds or 1ms
      outa[StepPin]~~                  ' Set StepPin HIGH to start pulse       1step @ fullstep = 0.9deg
       waitcnt(clkfreq / Speed + cnt)  ' Pulse HIGH time 15000 is less than 100 microseconds
                                       ' Pulse HIGH time 1_000 = 0.001 seconds or 1ms
      outa[StepPin]~                   ' Set StepPin LOW to end pulse
       waitcnt(clkfreq / Speed + cnt)  ' Pulse LOW time 15000 is less than 100 microseconds
                                       ' Pulse  time 1_000 = 0.001 seconds or 1ms
      StepCount := StepCount+2                                           

     If StepCount==Gear2

        LCD.tx(148)                    ' Move cursor to Line 1 position 0  
        LCD.Dec(StepCount)


         outa[EN_Pin]:=1               'Disable the Big Easy driver, make it High  



        return
 

pub ThirdGear
outa[EN_Pin]:=0                        'Enable the Big Easy driver        
Beenthere := 3
If StepCount==Gear3
  return
  
LCD.tx(12)                             ' Clear the LCD display
 waitcnt(clkfreq / 200+ cnt)           ' Pause for 5ms time for LCD display to clear
  
 LCD.str(string("CurrentGear"))        ' line 0 printed to LCD                                      
 LCD.tx(141)                           ' Move cursor to Line 0 position 13
 LCD.Dec(CurrentGear)                  ' Current Gear "1 through 8" printed to LCD
 LCD.tx(148)                           ' Move cursor to Line 1 position 0
 LCD.str(string("----------------"))   ' Print dashes across Line 1
 LCD.tx(212)                           ' Set quarter note
 LCD.tx(220)                           ' A tone      
'--------------------------------------------------------------------------------------------------------------
Repeat

   if StepCount > Gear3
    outa[Dirpin]~                      'Set Direction pin to LOW for Reverse     
      outa[StepPin]~~                  ' Set StepPin HIGH to start pulse       1step @ fullstep = 0.9deg
       waitcnt(clkfreq / Speed + cnt)  ' Pulse HIGH time 15000 is less than 100 microseconds
                                       ' Pulse HIGH time 1_000 = 0.001 seconds or 1ms
      outa[StepPin]~                   ' Set StepPin LOW to end pulse
       waitcnt(clkfreq / Speed + cnt)  ' Pulse LOW time 15000 is less than 100 microseconds
                                       ' Pulse  time 1_000 = 0.001 seconds or 1ms
      outa[StepPin]~~                  ' Set StepPin HIGH to start pulse       1step @ fullstep = 0.9deg
       waitcnt(clkfreq / Speed + cnt)  ' Pulse HIGH time 15000 is less than 100 microseconds
                                       ' Pulse HIGH time 1_000 = 0.001 seconds or 1ms
      outa[StepPin]~                   ' Set StepPin LOW to end pulse
       waitcnt(clkfreq / Speed + cnt)  ' Pulse LOW time 15000 is less than 100 microseconds
                                       ' Pulse  time 1_000 = 0.001 seconds or 1ms
       StepCount := StepCount-2                                           


     If StepCount==Gear3

        LCD.tx(148)                    ' Move cursor to Line 1 position 0  
        LCD.Dec(StepCount)


         outa[EN_Pin]:=1               'Disable the Big Easy driver, make it High  


          return

   if StepCount < Gear3
    outa[Dirpin]~~                     'Set Direction pin to High for Forward   
      outa[StepPin]~~                  ' Set StepPin HIGH to start pulse       1step @ fullstep = 0.9deg
       waitcnt(clkfreq / Speed + cnt)  ' Pulse HIGH time 15000 is less than 100 microseconds
                                       ' Pulse HIGH time 1_000 = 0.001 seconds or 1ms
      outa[StepPin]~                   ' Set StepPin LOW to end pulse
       waitcnt(clkfreq / Speed + cnt)  ' Pulse LOW time 15000 is less than 100 microseconds
                                       ' Pulse  time 1_000 = 0.001 seconds or 1ms
      outa[StepPin]~~                  ' Set StepPin HIGH to start pulse       1step @ fullstep = 0.9deg
       waitcnt(clkfreq / Speed + cnt)  ' Pulse HIGH time 15000 is less than 100 microseconds
                                       ' Pulse HIGH time 1_000 = 0.001 seconds or 1ms
      outa[StepPin]~                   ' Set StepPin LOW to end pulse
       waitcnt(clkfreq / Speed + cnt)  ' Pulse LOW time 15000 is less than 100 microseconds
                                       ' Pulse  time 1_000 = 0.001 seconds or 1ms
      StepCount := StepCount+2                                           

     If StepCount==Gear3

        LCD.tx(148)                    ' Move cursor to Line 1 position 0  
        LCD.Dec(StepCount)


         outa[EN_Pin]:=1               'Disable the Big Easy driver, make it High  


        return
 
pub fourthGear
outa[EN_Pin]:=0                        'Enable the Big Easy driver        
Beenthere := 4
If StepCount==Gear4
  return
  

LCD.tx(12)                             ' Clear the LCD display
 waitcnt(clkfreq / 200+ cnt)           ' Pause for 5ms time for LCD display to clear
  
 LCD.str(string("CurrentGear"))        ' line 0 printed to LCD                                      
 LCD.tx(141)                           ' Move cursor to Line 0 position 13
 LCD.Dec(CurrentGear)                  ' Current Gear "1 through 8" printed to LCD
 LCD.tx(148)                           ' Move cursor to Line 1 position 0
 LCD.str(string("----------------"))   ' Print dashes across Line 1
 LCD.tx(212)                           ' Set quarter note
 LCD.tx(220)                           ' A tone      
'--------------------------------------------------------------------------------------------------------------
Repeat

   if StepCount > Gear4
      outa[Dirpin]~                      'Set Direction pin to LOW for Reverse     
      outa[StepPin]~~                  ' Set StepPin HIGH to start pulse       1step @ fullstep = 0.9deg
       waitcnt(clkfreq / Speed + cnt)  ' Pulse HIGH time 15000 is less than 100 microseconds
                                       ' Pulse HIGH time 1_000 = 0.001 seconds or 1ms
      outa[StepPin]~                   ' Set StepPin LOW to end pulse
       waitcnt(clkfreq / Speed + cnt)  ' Pulse LOW time 15000 is less than 100 microseconds
                                       ' Pulse  time 1_000 = 0.001 seconds or 1ms
      outa[StepPin]~~                  ' Set StepPin HIGH to start pulse       1step @ fullstep = 0.9deg
       waitcnt(clkfreq / Speed + cnt)  ' Pulse HIGH time 15000 is less than 100 microseconds
                                       ' Pulse HIGH time 1_000 = 0.001 seconds or 1ms
      outa[StepPin]~                   ' Set StepPin LOW to end pulse
       waitcnt(clkfreq / Speed + cnt)  ' Pulse LOW time 15000 is less than 100 microseconds
                                       ' Pulse  time 1_000 = 0.001 seconds or 1ms
       StepCount := StepCount-2                                           


     If StepCount==Gear4

        LCD.tx(148)                    ' Move cursor to Line 1 position 0  
        LCD.Dec(StepCount)
         outa[EN_Pin]:=1               'Disable the Big Easy driver, make it High  
          return

   if StepCount < Gear4
    outa[Dirpin]~~                     'Set Direction pin to High for Forward   
      outa[StepPin]~~                  ' Set StepPin HIGH to start pulse       1step @ fullstep = 0.9deg
       waitcnt(clkfreq / Speed + cnt)  ' Pulse HIGH time 15000 is less than 100 microseconds
                                       ' Pulse HIGH time 1_000 = 0.001 seconds or 1ms
      outa[StepPin]~                   ' Set StepPin LOW to end pulse
       waitcnt(clkfreq / Speed + cnt)  ' Pulse LOW time 15000 is less than 100 microseconds
                                       ' Pulse  time 1_000 = 0.001 seconds or 1ms
      outa[StepPin]~~                  ' Set StepPin HIGH to start pulse       1step @ fullstep = 0.9deg
       waitcnt(clkfreq / Speed + cnt)  ' Pulse HIGH time 15000 is less than 100 microseconds
                                       ' Pulse HIGH time 1_000 = 0.001 seconds or 1ms
      outa[StepPin]~                   ' Set StepPin LOW to end pulse
       waitcnt(clkfreq / Speed + cnt)  ' Pulse LOW time 15000 is less than 100 microseconds
                                       ' Pulse  time 1_000 = 0.001 seconds or 1ms
      StepCount := StepCount+2                                           

     If StepCount==Gear4

        LCD.tx(148)                    ' Move cursor to Line 1 position 0  
        LCD.Dec(StepCount)


         outa[EN_Pin]:=1               'Disable the Big Easy driver, make it High  


        return
 
pub fifthGear
outa[EN_Pin]:=0        'Enable the Big Easy driver        
Beenthere := 5
If StepCount==Gear5
  return


LCD.tx(12)                             ' Clear the LCD display
 waitcnt(clkfreq / 200+ cnt)           ' Pause for 5ms time for LCD display to clear
  
 LCD.str(string("CurrentGear"))        ' line 0 printed to LCD                                      
 LCD.tx(141)                           ' Move cursor to Line 0 position 13
 LCD.Dec(CurrentGear)                  ' Current Gear "1 through 8" printed to LCD
 LCD.tx(148)                           ' Move cursor to Line 1 position 0
 LCD.str(string("----------------"))   ' Print dashes across Line 1
 LCD.tx(212)                           ' Set quarter note
 LCD.tx(220)                           ' A tone      
'--------------------------------------------------------------------------------------------------------------
Repeat

   if StepCount > Gear5
    outa[Dirpin]~                      'Set Direction pin to LOW for Reverse     
      outa[StepPin]~~                  ' Set StepPin HIGH to start pulse       1step @ fullstep = 0.9deg
       waitcnt(clkfreq / Speed + cnt)  ' Pulse HIGH time 15000 is less than 100 microseconds
                                       ' Pulse HIGH time 1_000 = 0.001 seconds or 1ms
      outa[StepPin]~                   ' Set StepPin LOW to end pulse
       waitcnt(clkfreq / Speed + cnt)  ' Pulse LOW time 15000 is less than 100 microseconds
                                       ' Pulse  time 1_000 = 0.001 seconds or 1ms
      outa[StepPin]~~                  ' Set StepPin HIGH to start pulse       1step @ fullstep = 0.9deg
       waitcnt(clkfreq / Speed + cnt)  ' Pulse HIGH time 15000 is less than 100 microseconds
                                       ' Pulse HIGH time 1_000 = 0.001 seconds or 1ms
      outa[StepPin]~                   ' Set StepPin LOW to end pulse
       waitcnt(clkfreq / Speed + cnt)  ' Pulse LOW time 15000 is less than 100 microseconds
                                       ' Pulse  time 1_000 = 0.001 seconds or 1ms
       StepCount := StepCount-2                                           


     If StepCount==Gear5

        LCD.tx(148)                    ' Move cursor to Line 1 position 0  
        LCD.Dec(StepCount)


         outa[EN_Pin]:=1               'Disable the Big Easy driver, make it High  


          return

   if StepCount < Gear5
    outa[Dirpin]~~                     'Set Direction pin to High for Forward   
      outa[StepPin]~~                  ' Set StepPin HIGH to start pulse       1step @ fullstep = 0.9deg
       waitcnt(clkfreq / Speed + cnt)  ' Pulse HIGH time 15000 is less than 100 microseconds
                                       ' Pulse HIGH time 1_000 = 0.001 seconds or 1ms
      outa[StepPin]~                   ' Set StepPin LOW to end pulse
       waitcnt(clkfreq / Speed + cnt)  ' Pulse LOW time 15000 is less than 100 microseconds
                                       ' Pulse  time 1_000 = 0.001 seconds or 1ms
      outa[StepPin]~~                  ' Set StepPin HIGH to start pulse       1step @ fullstep = 0.9deg
       waitcnt(clkfreq / Speed + cnt)  ' Pulse HIGH time 15000 is less than 100 microseconds
                                       ' Pulse HIGH time 1_000 = 0.001 seconds or 1ms
      outa[StepPin]~                   ' Set StepPin LOW to end pulse
       waitcnt(clkfreq / Speed + cnt)  ' Pulse LOW time 15000 is less than 100 microseconds
                                       ' Pulse  time 1_000 = 0.001 seconds or 1ms
      StepCount := StepCount+2                                           

     If StepCount==Gear5

        LCD.tx(148)                    ' Move cursor to Line 1 position 0  
        LCD.Dec(StepCount)


         outa[EN_Pin]:=1               'Disable the Big Easy driver, make it High  


        return
 
pub SixthGear
outa[EN_Pin]:=0                        'Enable the Big Easy driver         
Beenthere := 6
If StepCount==Gear6
  return
  

LCD.tx(12)                             ' Clear the LCD display
 waitcnt(clkfreq / 200+ cnt)           ' Pause for 5ms time for LCD display to clear
  
 LCD.str(string("CurrentGear"))        ' line 0 printed to LCD                                      
 LCD.tx(141)                           ' Move cursor to Line 0 position 13
 LCD.Dec(CurrentGear)                  ' Current Gear "1 through 8" printed to LCD
 LCD.tx(148)                           ' Move cursor to Line 1 position 0
 LCD.str(string("----------------"))   ' Print dashes across Line 1
 LCD.tx(212)                           ' Set quarter note
 LCD.tx(220)                           ' A tone      
'--------------------------------------------------------------------------------------------------------------
Repeat

   if StepCount > Gear6
    outa[Dirpin]~                      'Set Direction pin to LOW for Reverse     
      outa[StepPin]~~                  ' Set StepPin HIGH to start pulse       1step @ fullstep = 0.9deg
       waitcnt(clkfreq / Speed + cnt)  ' Pulse HIGH time 15000 is less than 100 microseconds
                                       ' Pulse HIGH time 1_000 = 0.001 seconds or 1ms
      outa[StepPin]~                   ' Set StepPin LOW to end pulse
       waitcnt(clkfreq / Speed + cnt)  ' Pulse LOW time 15000 is less than 100 microseconds
                                       ' Pulse  time 1_000 = 0.001 seconds or 1ms
      outa[StepPin]~~                  ' Set StepPin HIGH to start pulse       1step @ fullstep = 0.9deg
       waitcnt(clkfreq / Speed + cnt)  ' Pulse HIGH time 15000 is less than 100 microseconds
                                       ' Pulse HIGH time 1_000 = 0.001 seconds or 1ms
      outa[StepPin]~                   ' Set StepPin LOW to end pulse
       waitcnt(clkfreq / Speed + cnt)  ' Pulse LOW time 15000 is less than 100 microseconds
                                       ' Pulse  time 1_000 = 0.001 seconds or 1ms
       StepCount := StepCount-2                                           


     If StepCount==Gear6

        LCD.tx(148)                    ' Move cursor to Line 1 position 0  
        LCD.Dec(StepCount)


         outa[EN_Pin]:=1               'Disable the Big Easy driver, make it High  


          return

   if StepCount < Gear6
    outa[Dirpin]~~                     'Set Direction pin to High for Forward   
      outa[StepPin]~~                  ' Set StepPin HIGH to start pulse       1step @ fullstep = 0.9deg
       waitcnt(clkfreq / Speed + cnt)  ' Pulse HIGH time 15000 is less than 100 microseconds
                                       ' Pulse HIGH time 1_000 = 0.001 seconds or 1ms
      outa[StepPin]~                   ' Set StepPin LOW to end pulse
       waitcnt(clkfreq / Speed + cnt)  ' Pulse LOW time 15000 is less than 100 microseconds
                                       ' Pulse  time 1_000 = 0.001 seconds or 1ms
      outa[StepPin]~~                  ' Set StepPin HIGH to start pulse       1step @ fullstep = 0.9deg
       waitcnt(clkfreq / Speed + cnt)  ' Pulse HIGH time 15000 is less than 100 microseconds
                                       ' Pulse HIGH time 1_000 = 0.001 seconds or 1ms
      outa[StepPin]~                   ' Set StepPin LOW to end pulse
       waitcnt(clkfreq / Speed + cnt)  ' Pulse LOW time 15000 is less than 100 microseconds
                                       ' Pulse  time 1_000 = 0.001 seconds or 1ms
      StepCount := StepCount+2                                           

     If StepCount==Gear6

        LCD.tx(148)                    ' Move cursor to Line 1 position 0  
        LCD.Dec(StepCount)


         outa[EN_Pin]:=1               'Disable the Big Easy driver, make it High  


        return
 
pub SeventhGear
outa[EN_Pin]:=0        'Enable the Big Easy driver        
Beenthere := 7
If StepCount==Gear7
  return


LCD.tx(12)                             ' Clear the LCD display
 waitcnt(clkfreq / 200+ cnt)           ' Pause for 5ms time for LCD display to clear
  
 LCD.str(string("CurrentGear"))        ' line 0 printed to LCD                                      
 LCD.tx(141)                           ' Move cursor to Line 0 position 13
 LCD.Dec(CurrentGear)                  ' Current Gear "1 through 8" printed to LCD
 LCD.tx(148)                           ' Move cursor to Line 1 position 0
 LCD.str(string("----------------"))   ' Print dashes across Line 1
 LCD.tx(212)                           ' Set quarter note
 LCD.tx(220)                           ' A tone      
'--------------------------------------------------------------------------------------------------------------
Repeat

   if StepCount > Gear7
    outa[Dirpin]~                      'Set Direction pin to LOW for Reverse     
      outa[StepPin]~~                  ' Set StepPin HIGH to start pulse       1step @ fullstep = 0.9deg
       waitcnt(clkfreq / Speed + cnt)  ' Pulse HIGH time 15000 is less than 100 microseconds
                                       ' Pulse HIGH time 1_000 = 0.001 seconds or 1ms
      outa[StepPin]~                   ' Set StepPin LOW to end pulse
       waitcnt(clkfreq / Speed + cnt)  ' Pulse LOW time 15000 is less than 100 microseconds
                                       ' Pulse  time 1_000 = 0.001 seconds or 1ms
      outa[StepPin]~~                  ' Set StepPin HIGH to start pulse       1step @ fullstep = 0.9deg
       waitcnt(clkfreq / Speed + cnt)  ' Pulse HIGH time 15000 is less than 100 microseconds
                                       ' Pulse HIGH time 1_000 = 0.001 seconds or 1ms
      outa[StepPin]~                   ' Set StepPin LOW to end pulse
       waitcnt(clkfreq / Speed + cnt)  ' Pulse LOW time 15000 is less than 100 microseconds
                                       ' Pulse  time 1_000 = 0.001 seconds or 1ms
       StepCount := StepCount-2                                           


     If StepCount==Gear7

        LCD.tx(148)                    ' Move cursor to Line 1 position 0  
        LCD.Dec(StepCount)


         outa[EN_Pin]:=1               'Disable the Big Easy driver, make it High  


          return

   if StepCount < Gear7
    outa[Dirpin]~~                     'Set Direction pin to High for Forward   
      outa[StepPin]~~                  ' Set StepPin HIGH to start pulse       1step @ fullstep = 0.9deg
       waitcnt(clkfreq / Speed + cnt)  ' Pulse HIGH time 15000 is less than 100 microseconds
                                       ' Pulse HIGH time 1_000 = 0.001 seconds or 1ms
      outa[StepPin]~                   ' Set StepPin LOW to end pulse
       waitcnt(clkfreq / Speed + cnt)  ' Pulse LOW time 15000 is less than 100 microseconds
                                       ' Pulse  time 1_000 = 0.001 seconds or 1ms
      outa[StepPin]~~                  ' Set StepPin HIGH to start pulse       1step @ fullstep = 0.9deg
       waitcnt(clkfreq / Speed + cnt)  ' Pulse HIGH time 15000 is less than 100 microseconds
                                       ' Pulse HIGH time 1_000 = 0.001 seconds or 1ms
      outa[StepPin]~                   ' Set StepPin LOW to end pulse
       waitcnt(clkfreq / Speed + cnt)  ' Pulse LOW time 15000 is less than 100 microseconds
                                       ' Pulse  time 1_000 = 0.001 seconds or 1ms
      StepCount := StepCount+2                                           

     If StepCount==Gear7

        LCD.tx(148)                    ' Move cursor to Line 1 position 0  
        LCD.Dec(StepCount)


         outa[EN_Pin]:=1               'Disable the Big Easy driver, make it High  


        return
 

pub EighthGear
outa[EN_Pin]:=0                        'Enable the Big Easy driver        
Beenthere := 8
If StepCount==Gear8
  return
  
LCD.tx(12)                             ' Clear the LCD display
 waitcnt(clkfreq / 200+ cnt)           ' Pause for 5ms time for LCD display to clear
  
 LCD.str(string("CurrentGear"))        ' line 0 printed to LCD                                      
 LCD.tx(141)                           ' Move cursor to Line 0 position 13
 LCD.Dec(CurrentGear)                  ' Current Gear "1 through 8" printed to LCD
 LCD.tx(148)                           ' Move cursor to Line 1 position 0
 LCD.str(string("----------------"))   ' Print dashes across Line 1
 LCD.tx(212)                           ' Set quarter note
 LCD.tx(220)                           ' A tone      
'--------------------------------------------------------------------------------------------------------------
Repeat

   if StepCount > Gear8
    outa[Dirpin]~                      'Set Direction pin to LOW for Reverse     
      outa[StepPin]~~                  ' Set StepPin HIGH to start pulse       1step @ fullstep = 0.9deg
       waitcnt(clkfreq / Speed + cnt)  ' Pulse HIGH time 15000 is less than 100 microseconds
                                       ' Pulse HIGH time 1_000 = 0.001 seconds or 1ms
      outa[StepPin]~                   ' Set StepPin LOW to end pulse
       waitcnt(clkfreq / Speed + cnt)  ' Pulse LOW time 15000 is less than 100 microseconds
                                       ' Pulse  time 1_000 = 0.001 seconds or 1ms
      outa[StepPin]~~                  ' Set StepPin HIGH to start pulse       1step @ fullstep = 0.9deg
       waitcnt(clkfreq / Speed + cnt)  ' Pulse HIGH time 15000 is less than 100 microseconds
                                       ' Pulse HIGH time 1_000 = 0.001 seconds or 1ms
      outa[StepPin]~                   ' Set StepPin LOW to end pulse
       waitcnt(clkfreq / Speed + cnt)  ' Pulse LOW time 15000 is less than 100 microseconds
                                       ' Pulse  time 1_000 = 0.001 seconds or 1ms
       StepCount := StepCount-2                                           


     If StepCount==Gear8

        LCD.tx(148)                    ' Move cursor to Line 1 position 0  
        LCD.Dec(StepCount)


         outa[EN_Pin]:=1               'Disable the Big Easy driver, make it High  


          return

   if StepCount < Gear8
    outa[Dirpin]~~                     'Set Direction pin to High for Forward   
      outa[StepPin]~~                  ' Set StepPin HIGH to start pulse       1step @ fullstep = 0.9deg
       waitcnt(clkfreq / Speed + cnt)  ' Pulse HIGH time 15000 is less than 100 microseconds
                                       ' Pulse HIGH time 1_000 = 0.001 seconds or 1ms
      outa[StepPin]~                   ' Set StepPin LOW to end pulse
       waitcnt(clkfreq / Speed + cnt)  ' Pulse LOW time 15000 is less than 100 microseconds
                                       ' Pulse  time 1_000 = 0.001 seconds or 1ms
      outa[StepPin]~~                  ' Set StepPin HIGH to start pulse       1step @ fullstep = 0.9deg
       waitcnt(clkfreq / Speed + cnt)  ' Pulse HIGH time 15000 is less than 100 microseconds
                                       ' Pulse HIGH time 1_000 = 0.001 seconds or 1ms
      outa[StepPin]~                   ' Set StepPin LOW to end pulse
       waitcnt(clkfreq / Speed + cnt)  ' Pulse LOW time 15000 is less than 100 microseconds
                                       ' Pulse  time 1_000 = 0.001 seconds or 1ms
      StepCount := StepCount+2                                           

     If StepCount==Gear8

        LCD.tx(148)                    ' Move cursor to Line 1 position 0  
        LCD.Dec(StepCount)


         outa[EN_Pin]:=1               'Disable the Big Easy driver, make it High  


        return

Pub JOG

{{ I need JOG to run the motor and keep track of StepCount which is initially set to 500 or 1 1/4 revolutions.
   Maybe I'll need to set StepCount to 400 which will be exactly one revolution, but we'll see about that.

   After jogging the motor to position, I need to make the variables Gear1 through Gear8 = StepCount.
   SO:
   One button should jog forward
   One button should jog reverse
   one button should select the Gear 1 through 8
   One button should change the value of Gear 1 through 8 to current StepCount.

 }}
'*************************************************
'Here you select which gear you are working with.  \/
'***********
 LCD.tx(12)                         ' Clear the LCD display
 waitcnt(clkfreq / 200+ cnt)        ' Pause for 5ms time for LCD display to clear
  
 LCD.str(string("CurrentGear="))    ' line 0 printed to LCD                          
 LCD.tx(140)                        ' Line 0 position 12
 LCD.Dec(CurrentGear)               ' CurrentGear printed to line 0, position 12
 LCD.tx(148)                        ' Move cursor to Line 1 position 0
 LCD.str(string("Select Gear"))    ' This shows you are in the JOG method

  Waitpne (|<BUTN1, |<BUTN1, 0)          'Pause program execution until button BUTN1 is NOT pressed .    
                                         'I'm not sure if this is correct place for this Waitpne instruction.
                                         'BUTN1 needs to not be pressed for this method to run correctly.  

     Repeat         'Endless Loop               
                                               
              If INA[BUTN3]==0           'BUTN3 must be released before CurrentGear can again advance
                    Flag3:=0 
     
              If INA[BUTN4]==0           'BUTN4 must be released before CurrentGear can again advance
                    Flag4:=0
                    
              If INA[BUTN3]==1          'Here I'm attempting to make an AND statement with IF statements.
     
                 If Flag3==0             'When written like "IF INA[BUTN3]==1 and flag==0" DOES NOT WORK. 
                                             'I can compare two buttons, but not button and variable value.
                    Flag3:=1
     
                    CurrentGear:= CurrentGear-1 
                    If CurrentGear<1
                       CurrentGear:=1
     
                    outa[BUTNCOGLED]~~                  ' Set BUTNCOGLED HIGH to start pulse   
                   LCD.tx(12)                         ' Clear the LCD display
                   waitcnt(clkfreq / 200+ cnt)        ' Pause for 5ms time for LCD display to clear
       
                   LCD.str(string("CurrentGear="))    ' line 0 printed to LCD                                      
                   LCD.tx(140)                        ' Line 0 position 12
                   LCD.Dec(CurrentGear)               ' CurrentGear printed to line 0, position 12
                   LCD.tx(212)                        ' Set quarter note
                   LCD.tx(220)                        ' A tone      
                   outa[BUTNCOGLED]~                 ' Set BUTNCOGLED Low  
     
     
     
     
              If INA[BUTN4]==1 
     
                 If Flag4==0         
                    Flag4:=1
                    CurrentGear:= CurrentGear+1
                    If CurrentGear>8
                       CurrentGear:=8
     
                    outa[BUTNCOGLED]~~                 ' Set BUTNCOGLED HIGH to start pulse   
                    LCD.tx(12)                         ' Clear the LCD display
                    waitcnt(clkfreq / 200+ cnt)        ' Pause for 5ms time for LCD display to clear
       
                    LCD.str(string("CurrentGear="))    ' line 0 printed to LCD                                      
                    LCD.tx(140)                        ' Line 0 position 12
                    LCD.Dec(CurrentGear)               ' CurrentGear printed to line 0, position 12
                    LCD.tx(212)                        ' Set quarter note
                    LCD.tx(220)                        ' A tone      
                    outa[BUTNCOGLED]~                 ' Set BUTNCOGLED Low  
     
     

          if ina[BUTN1]==1

              quit                              
                     
     ' ***********************************************************************
     'Here you jog the stepper until the derail is lined up properly for the current gear \/
     ' ****************  
     'This prints on Line 1
     LCD.tx(148)                              'Move Cursor to Line 1 position 0
      LCD.str(string("                "))      'Print 16 spaces on Line 1
      LCD.tx(148)                             'Move Cursor to Line 1 position 0   
      LCD.str(string("JOGGING"))            ' line 1 printed to LCD                                      
      LCD.tx(156)                           ' Move cursor to Line 1 position 8
      LCD.Str(string("        "))           'Clear Line 1 positions 8 through 16
      LCD.tx(156)                           ' Move cursor to Line Line1 position 8    
      LCD.Dec(StepCount)                    'StepCount data printed to Line 1
      LCD.tx(156)                           ' Move cursor to Line Line 1 position 8    
      LCD.tx(212)                           ' Set quarter note
      LCD.tx(223)                           ' C tone      
     '--------------------------------------------------------------------------------------------------------------



  Waitpne (|<BUTN1, |<BUTN1, 0)          'Pause program execution until button BUTN1 is NOT pressed .    
                                         'I'm not sure if this is correct place for this Waitpne instruction.
                                         'BUTN1 needs to not be pressed for this method to run correctly.  


         Repeat
 
                  if INA[BUTN1]==1
              

                    outa[EN_Pin]:=1               'Disable the Big Easy driver, make it High    
                    quit
                           
            if INA[BUTN3]==1

                outa[EN_Pin]:=0                           'Enable the Big Easy driver     

               outa[Dirpin]~                      'Set Direction pin to LOW for Reverse     
               outa[StepPin]~~                  ' Set StepPin HIGH to start pulse       1step @ fullstep = 0.9deg
                waitcnt(clkfreq / 1000 + cnt)   ' Pulse HIGH time 15000 is less than 100 microseconds
                                                ' Pulse HIGH time 1_000 = 0.001 seconds or 1ms
               outa[StepPin]~                   ' Set StepPin LOW to end pulse
                waitcnt(clkfreq / 1000 + cnt)   ' Pulse LOW time 15000 is less than 100 microseconds
                                                ' Pulse  time 1_000 = 0.001 seconds or 1ms
               outa[StepPin]~~                  ' Set StepPin HIGH to start pulse       1step @ fullstep = 0.9deg
                waitcnt(clkfreq / 1000 + cnt)   ' Pulse HIGH time 15000 is less than 100 microseconds
                                                ' Pulse HIGH time 1_000 = 0.001 seconds or 1ms
               outa[StepPin]~                   ' Set StepPin LOW to end pulse
                waitcnt(clkfreq / 1000 + cnt)   ' Pulse LOW time 15000 is less than 100 microseconds
                                                ' Pulse  time 1_000 = 0.001 seconds or 1ms
                StepCount := StepCount-2                                           
    
                  LCD.tx(156)                           ' Move cursor to Line Line1 position 8
                  LCD.Str(string("        "))           'Clear Line1 positions 8 through 16
                  LCD.tx(156)                           ' Move cursor to Line Line1 position 8 
                  LCD.Dec(StepCount)                    'StepCount data printed to Line 1

                  outa[EN_Pin]:=1               'Disable the Big Easy driver, make it High  


            if INA[BUTN4]==1 

                outa[EN_Pin]:=0                           'Enable the Big Easy driver     
 
               outa[Dirpin]~~                     'Set Direction pin to High for Forward   
               outa[StepPin]~~                  ' Set StepPin HIGH to start pulse       1step @ fullstep = 0.9deg
                waitcnt(clkfreq / Speed + cnt)  ' Pulse HIGH time 15000 is less than 100 microseconds
                                                ' Pulse HIGH time 1_000 = 0.001 seconds or 1ms
               outa[StepPin]~                   ' Set StepPin LOW to end pulse
                waitcnt(clkfreq / Speed + cnt)  ' Pulse LOW time 15000 is less than 100 microseconds
                                                ' Pulse  time 1_000 = 0.001 seconds or 1ms
               outa[StepPin]~~                  ' Set StepPin HIGH to start pulse       1step @ fullstep = 0.9deg
                waitcnt(clkfreq / Speed + cnt)  ' Pulse HIGH time 15000 is less than 100 microseconds
                                                ' Pulse HIGH time 1_000 = 0.001 seconds or 1ms
               outa[StepPin]~                   ' Set StepPin LOW to end pulse
                waitcnt(clkfreq / Speed + cnt)  ' Pulse LOW time 15000 is less than 100 microseconds
                                                ' Pulse  time 1_000 = 0.001 seconds or 1ms
               StepCount := StepCount+2                                           

                  LCD.tx(156)                           ' Move cursor to Line Line1 position 8
                  LCD.Str(string("        "))           'Clear Line1 positions 8 through 16
                  LCD.tx(156)                           ' Move cursor to Line Line1 position 8 
                  LCD.Dec(StepCount)                    'StepCount data printed to Line 1

                  outa[EN_Pin]:=1               'Disable the Big Easy driver, make it High  


     Case CurrentGear                           'The value of CurrentGear is the gear I want to work with.  

          1 : 'Firstgear                        'Value of CurrentGear is put into the Gear1 through Gear8 variables
              Gear1:= Stepcount
          2 : 'SecondGear
              Gear2:= Stepcount
          3 : 'ThirdGear
              Gear3:= Stepcount
          4 : 'FourthGear
              Gear4:= Stepcount 
          5 : 'FifthGear
              Gear5:= Stepcount 
          6 : 'SixthGear
              Gear6:= Stepcount 
          7 : 'SeventhGear
              Gear7:= Stepcount 
          8 : 'EighthGear
              Gear8:= Stepcount


 MENUE:=4       'If MENUE is equal to 4, the implied return sends program back to MAIN_MENUE, where the
                'repeat loop is canceled.   
                                      
{{ Once the code is finished running in this method, program will automatically return to Main_Menue.}}

pub SaveToEEPROM
{{ There is nothing in this method as yet.
   I need to be able to save the Gear1 through Gear8 values to the eeprom so they don't get lost when the
   PropMini is powered down and then powered up again.
}}   
  LCD.tx(12)                            ' Clear the LCD display
  waitcnt (60_000 + cnt)                ' Pause for 5ms time for LCD display to clear
  
  LCD.str(string("SaveToEEPROM"))       ' line 0 printed to LCD                                      
  LCD.tx(13)                            ' Line feed
  LCD.str(string("Nothing Here Yet"))   ' line 1 printed to LCD
  LCD.tx(212)                           ' Set quarter note
  LCD.tx(220)                           ' A tone           

  Waitpne (|<BUTN1, |<BUTN1, 0)          'Pause program execution until button ina[8] is NOT pressed .  
  Waitpeq (|<BUTN1, |<BUTN1, 0)          'Pause program execution until button ina[8] is pressed and held.  

 MENUE:=4       'If MENUE is equal to 4, the implied return sends program back to MAIN_MENUE, where the
                'repeat loop is canceled.   
                                      
{{ Once the code is finished running in this method, program will automatically return to Main_Menue.}}